{-----------------------------------------------------------------------------}
{ Handle assembly language directives.                           (c) 1992 YGP }

    procedure do_section;
    begin { do_section }
      if c_flags and _c_section <> 0 then
        error(e_sec_nest)
      else begin
	sec_apc:= apc; sec_nesting:= 0;
	sect_include:= inc_nesting;
      end { if };
      c_flags:= c_flags or _c_section;
      inc(sec_nesting);

      expression(false, false);
      case gv.v_kind of
        v_none:;

	v_cnst: begin                                              {$ifdef lst}
	  lst_code:= _lst_equ;                                         {$endif}
          if (gv.l < 0) or (65536 < gv.l) then begin
	    error(e_sec_range);
          end { if };
          apc._mod:= 0; apc.pc:= gv.l;
        end { when constant section address };

      else(*):(*)
	unimplemented('section address');
	error(e_sec_expr);
      end { case };
    end { do_section };

    procedure do_ends;
    begin { do_ends }
      if (c_flags and _c_section = 0)  then
        error(e_no_sect)
      else begin
        dec(sec_nesting);
        if sec_nesting = 0 then begin
	  apc:= sec_apc; c_flags:= c_flags and (word($ffff) xor _c_section);
	  if (inc_nesting <> sect_include) then error(e_no_sect);
        end { if };
      end { if };
    end { do_ends };

    procedure do_DS;
      var rbra: boolean; n: longint;
    begin { do_DS }
      expression(false, false);
      case gv.v_kind of
	v_none: ;

	v_cnst: begin
	  if (gv.l < 0) or (65536 < gv.l) then
	    error(e_ds_range)
	  else begin
	    {$ifdef lst}
	      sy:= comment_line;        {       }
              inc(APC.pc, gv.l);
	      if c_flags and _c_section = 0 then begin
		inc(code_size, gv.l);
		lst_code:= _lst_nbytes;
	      end { if };
	    {$else}
	      n:= gv.l;
	      rbra:= sy = l_bra;
	      if not(rbra or (sy = comma)) then
		gv.l:= 0
	      else begin
		insy; expression(false, false);
	      end { if };

	      if rbra then begin
		if sy <> r_bra then
		  error(e_r_bra)
		else begin
		  insy;
		end { if };
	      end { if };

	      case gv.v_kind of
		v_none: ;

		v_cnst: begin
		  if APC.pc + n > 65536 then
		    error(e_ds_range)
		  else begin
		    _gen_lobytes(w_not_byte, n);
		  end { if };
		end { v_cnst };

	      else(*):(*)
		unimplemented('value of ds');
	      end { case };
	    {$endif}
	  end { if };
	end { when constant };

      else(*):(*)
	unimplemented('not a constant expression');
	{          }
      end { case };
    end { do_DS };

    type def_type = (d_DB, d_LSB, d_MSB, d_DWP, d_DWN, d_DLP, d_DLN);

    function get_multiplikator: longint;
      var lv: value;
    begin { get_multiplikator }
      get_multiplikator:= 1;
      if sy = l_bra then begin
	lv:= gv;
        insy; expression(false, false);
	if (gv.v_kind <> v_cnst) or (gv.l < 0) then
          error(e_inv_mpl)
        else begin
          get_multiplikator:= gv.l;
        end { if };
        if sy = r_bra then
          insy
        else begin
          error(e_r_bra);
	end { if };
	gv:= lv;
      end { if };
    end { get_multiplikator };

    procedure do_def(what: def_type; item_size: shortcard
		     {$ifdef lst}; list_code: lst_ctype {$endif});
      var has_mpl, is_comma: boolean; i: integer; n: longint;
    begin { do_def }                                               {$ifdef lst}
      if c_flags and _c_section = 0 then lst_code:= list_code;         {$endif}
      repeat n:= 1; has_mpl:= false;
        if sy = l_bra then begin
          n:= get_multiplikator;
          has_mpl:= true;
        end { if };
	expression(what <= d_LSB, false);
        if sy = l_bra then begin
          n:= get_multiplikator;
          if has_mpl then begin
	    error(e_mpl2many);
          end { if };
        end { if };

	if (65536 < APC.pc + n * item_size) then begin
	  error(e_def_size);
	end { if };
        case gv.v_kind of
          v_none: ;

          v_expr: begin
            {$ifdef lst}
              inc(APC.pc, item_size*n);
              if c_flags and _c_section = 0 then inc(code_size, item_size*n);
            {$else}
	      case what of
		d_DB: begin
		  _gen_lobytes(w_not_byte, n);
		end { d_DB };

		d_LSB: begin
		  _gen_lobytes(e_no_error, n);
		end { when define LSB };

		d_DWP: begin
		  _gen_words(e_no_error, n);
		end { when define word };

		d_DLP: begin
		  _gen_longs(e_no_error, n);
		end { when define word };

              else(*):(*)
                unimplemented('define');
              end { case };
            {$endif}
          end { when expression };

          v_cnst: begin
            {$ifdef lst}
              inc(APC.pc, item_size*n);
              if c_flags and _c_section = 0 then inc(code_size, item_size*n);
            {$else}
	      case what of
		d_DB:  begin                  _gen_lobytes(w_not_byte, n); end;
		d_LSB: begin                  _gen_lobytes(e_no_error, n); end;
		d_MSB: begin gv.l:= hi(gv.l); _gen_lobytes(e_no_error, n); end;
		d_DWP: begin                    _gen_words(e_no_error, n); end;
		d_DWN: begin gv.l:= swap(gv.l); _gen_words(e_no_error, n); end;
		d_DLP: begin                    _gen_longs(e_no_error, n); end;
		d_DLN: begin gv.l:= longswap(gv.l);
		  _gen_longs(e_no_error, n);
		end;
              end { case };
            {$endif}
          end { v_cnst };

          v_str: begin                   {         LSB }
            {$ifdef lst}
              inc(APC.pc, n*length(gv.s^));
              if c_flags and _c_section =0 then inc(code_size,n*length(gv.s^));
	    {$else}
	      if 65536 < APC.pc + n*length(gv.s^) then
		error(e_def_size)
	      else begin
		while n > 0 do begin
		  dec(n);
		  for i:= 1 to length(gv.s^) do begin      {   }
		    gen_byte(ord(gv.s^[i]));                {    }
                  end { for };
		end { while };
	      end { if };
            {$endif}
                             {        }
            (*) freememwords(gv.s, length(gv.s^) div 2 +1)
            {*) freemem(gv.s, length(gv.s^)+1) {*}
          end { when string };

        else(*):(*)
          error(se_db1);
        end { case };
        is_comma:= sy = comma;
        if is_comma then insy;
      until not is_comma;
    end { do_def };

    procedure do_equ;
      var wid: identifier; apc: apc_rec; lidp: idp;                {$ifdef lst}
	  wrk_val: value;                                              {$endif}
    begin                                                          {$ifdef lst}
      lst_code:= _lst_equ;                                             {$endif}

      wid.id_flags:= 0;

      expression(false, false);                                    {$ifdef lst}
      wrk_val:= gv;                                                    {$endif}
      case gv.v_kind of
        v_none: begin    {    (   expr)   }
	  define_label(_apc, sv_psize, sv_pname);{  }{$ifdef lst}
	  gv.v_kind:= v_none;                                          {$endif}
          (*) return {*) exit {*};
        end { when v_none };

	v_expr: begin
	  wid.id_type:= id_expression; wid.elst:= nil;
	  gv.ex^.kind:= _e_ident;
	end { when expression };

        v_real: begin
          wid.id_type:= id_real; wid.rval:= gv.r;
        end { when real };

        v_cnst: begin
          if 0 <= gv.l then begin
            if 65535 < gv.l then begin
              wid.id_type:= id_lint; wid.lval:= gv.l; end
            else begin             { 0..65535 define it like absolute address }
              with apc do begin
		_mod:= 0; pc:= gv.l;
                define_label(apc, sv_psize, sv_pname);
	      end { with };                                        {$ifdef lst}
	      gv:= wrk_val;                                            {$endif}
	      (*) return {*) exit {*};
	    end { if }; end
	  (*
          else if -256 <= gv.l then begin                    { range -1..-256 }
	    wid.id_type:= id_nbyte; wid.bval:= lo(gv.l); end
	  *)
          else if -65536 <= gv.l then begin                { range -1..-65536 }
            wid.id_type:= id_nword; wid.wval:= loword(gv.l); end
          else begin                                     { full longint range }
            wid.id_type:= id_lint; wid.lval:= gv.l;
          end { if };
        end { when constant };

      else (*):(*)
	unimplemented('equ or =');
      end { case };

    (*      define_label -> *)
      lidp:= find_lab(sv_psize, sv_pname);          {     ident }
      if lidp = nil then begin
        if local_label and (lvl <> nil) then
	  lidp:= insert_lab(sv_psize, sv_pname, wid, lvl^.labs)
        else begin
          lidp:= insert_lab(sv_psize, sv_pname, wid, global_labs)
	end { if };
(**)	if wid.id_type = id_expression then begin
(**)  	  gv.ex^.eidp:= lidp;
(**)	end { if }; end
      else if (lidp^.id_type > id_forward) or
              local_label and (flvl <> lvl) then begin
	unpack_ident(sv_psize, sv_pname, idnm);
	err_sy:= ident; error(e_redef); end
      else begin                                     { forward declared label }
	if not local_label then wid.id_flags:= wid.id_flags or _i_global;
(**)    if wid.id_type = id_expression then begin
(**)  	  gv.ex^.eidp:= lidp; lidp^.id_type:= id_expression; end
(**)    else begin
	  def_forward(lidp, wid);             { define forward declared label }
	end { if };
      end { if };
    (* <-         define_label *)
								   {$ifdef lst}
      gv:= wrk_val;                                                    {$endif}
      {$ifdef change_psize}
      sv_psize:= 0;
      {$endif}
    end { do_equ };

    (*) segment (*)
    procedure do_checksum;
    begin                                                          {$ifdef lst}
      lst_code:= _lst_bytes; inc(apc.pc); inc(code_size);               {$else}
      if (c_flags and (_c_bin_file+ _c_cmd_file) = 0) then
        error(e_inv_sum)
      else if chk_offset >= 0 then begin
        error(e_inv_sum)
      end { if };
      chk_offset:= code_size;
      gen_byte(0);                                                     {$endif}
    end { do_checksum };

    (*) segment (*)
    procedure do_ORG;
    begin
      expression(false, false);
      case gv.v_kind of
	v_none: ;

	v_cnst: begin                                              {$ifdef lst}
	  lst_code:= _lst_equ;                                         {$endif}
          if (gv.l < 0) or (65536 < gv.l) then begin
	    error(e_org_range);
          end { if };
	  apc._mod:= 0; apc.pc:= gv.l;

	  if (c_flags and (_c_section +
			   _c_obj_file+ _c_pgm_file+
			   _c_bin_file+ _c_cmd_file) = 0) then begin
	    if gv.l = $100 then
	      c_flags:= c_flags or _c_cmd_file
	    else begin
	      c_flags:= c_flags or _c_bin_file
	    end { if };
	  end { if };
	end { v_cnst };

      else(*):(*)
	unimplemented('org');
	error(e_org_expr);
      end { case };
    end { do_ORG };

    (*) segment (*)
    procedure do_END;
    begin
    end { do_END };

    procedure do_procedure;
      const global = 'GLOBAL';
      var l: level_ptr;
    begin { do_procedure }
      inc(proc_nesting);
      new(l);
      with l^ do begin
        prev:= lvl;                                         {   }
	fillchar(labs, sizeof(labs), #0);          {     }
        pnam:= lab_name;
      end { with };

      if sv_psize <> 0 then define_label(_apc, sv_psize, sv_pname);
      lvl:= l;
    end { do_procedure };

    procedure do_endproc;
      var l: level_ptr;
    begin { do_endproc }
      if proc_nesting = 0 then
        error(e_unendp)
      else begin
        if sv_psize = 0 then lab_name:= '';
        if not local_label then error(e_cln_pnm);
        if (lab_name = '') and (sy = ident) then begin
          lab_name:= idnm; insy;
        end { if };
        if lab_name <> '' then begin
          if lab_name <> lvl^.pnam then begin
            error(e_pnm_mtch)
          end { if };
        end { if };

        {    level }
        dispose_tree(lvl^.labs, lvl^.prev, false);
        l:= lvl; lvl:= lvl^.prev; dispose(l);
        dec(proc_nesting);
      end { if };
    end { do_endproc };

    procedure do_error;
    begin
      expression(false, false);
      case gv.v_kind of
	v_none: ;

	v_cnst: begin
	  if gv.l <> 0 then begin
	    err_sy:= constant; lastlint:= gv.l;
	    error(e_usr_error);
	  end { if };
	end { v_cnst };

	v_expr: begin
          gv.ex^.offs:= code_size;
	  gv.ex^.kind:= _e_dummy + _e_usrerr
	end { when expression };

      else (*):(*)
	unimplemented('unresolved error directive');
      end { case };
    end { do_error };

    procedure do_include;
      var s: string;
    begin           {      (..     insy) }
      {        (    ).          }
      skip_spaces;             {      . }
      if sy = EOF_sy then
        error(e_empty_fnm)
      else begin
        get_str_no_quote(s);             {   ,    }
        insy;
        if sy > comment_line then begin
          error(e_garbage);
        end { if };
        skip_line;                      {       }
        {$ifdef lst}
          list_line;
        {$endif}
        if s = '' then
          error(e_empty_fnm)
        else begin
          include_source(s, i_path);          {   include    }
        end { if };
      end { if };
    end { do_include };

    (*) segment (*)
    procedure do_trunc_list;
    begin
      if sy <> ident then
        error(e_inv_trnc)
      else if idnm = 'ON' then
        l_flags:= l_flags and (_l_notrunc xor word($ffff))
      else if idnm = 'OFF' then
        l_flags:= l_flags or _l_notrunc
      else begin
        error(e_inv_trnc)
      end { if };
      insy;
    end { do_trunc_list };

    (*) segment (*)
    procedure do_list;
    begin
      l_flags:= l_flags or _l_line;
      if sy <> ident then
        error(e_inv_lst)
      else if idnm = 'ON' then
        l_flags:= l_flags or _l_on
      else if idnm = 'OFF' then
        l_flags:= l_flags and (_l_on xor word($ffff))
      else if idnm = 'TRUE' then
      else if idnm = 'FALSE' then
      else begin
        error(e_inv_lst)
      end { if };
      insy;
    end { do_list };

    procedure do_if_elsif;

      function defined: boolean;

        function term: boolean;

          function factor: boolean;
          begin { factor }
            case sy of
              ident: begin
                factor:= search_lab(pack_size, pack_name, cc_defined) <> nil;
                insy;
              end { when ident };

              not_sy: begin
                insy; factor:= not factor;
              end { when NOT };

              l_par: begin
                insy; factor:= defined;
                if sy = r_par then
                  insy
                else begin
                  error(e_r_par)
                end { if };
              end { when ( };
            end { case };
          end { factor };

          var ok: boolean;
        begin { term }
          ok:= factor;
          while sy = or_sy do begin
            insy; ok:= ok or factor;
          end { while };
          term:= ok;
        end { term };

        var ok: boolean;
      begin { defined }
        ok:= term;
        while sy = and_sy do begin
          insy; ok:= ok and term;
        end { while };
        defined:= ok;
      end { defined };

      var not_ok: boolean;
    begin
      case drctv of
        d_ifdef:  not_ok:= not defined;
        d_ifNdef: not_ok:= defined;
	d_if: begin
	  expression(false, false);
	  case gv.v_kind of
	    v_none: ;

	    v_cnst: begin                                          {$ifdef lst}
	      lst_code:= _lst_equ;                                     {$endif}
	      not_ok:= gv.l = 0;
	    end { v_cnst };

	  else(*):(*)
	    error(e_if_expr);
	  end { case };
        end { when if };
      else(*):(*)
        error(se_ifdef);
      end { case };
      dec(cc_compile, ord(not_ok));
    end { do_if_elsif };

    procedure do_define;
      var lid: identifier;
    begin { do_define }
      if sy <> ident then
        error(e_ident_exp)
      else begin
        lid.id_type:= id_defined;
        if insert_lab(pack_size, pack_name, lid, cc_defined) = nil then
          unimplemented('no space for define');
        insy;
      end { if };
    end { do_define };

    procedure do_undef;
    begin { do_undef }
      unimplemented('undefine');
    end { do_undef };

{-----------------------------------------------------------------------------}