{-----------------------------------------------------------------------------}
{ Global consts, types and vars for assembly language compiler.  (c) 1992 YGP }

  const _c_eof =        $0001;                          { end of include file }
        _c_section =    $0002;                               { inside section }
        _c_alternate =  $0008;        { use alternate syntax for instructions }
        _c_obj_file =   $0010;                   {    obj  }
        _c_pgm_file =   $0020;                   {    pgm  }
        _c_bin_file =   $0040;                     {    bin  }
        _c_cmd_file =   $0080;                     {    cmd  }
        _c_real_only =  $0200;                  {     }
        _c_new_file =   $0400;                  {    source file }
        _c_talkmem =    $0800;         {         }
        _c_gen_err =    $1000;                          { generate error file }
        _c_err_wait =   $2000;               {      }
        _c_inited =     $4000;  {        }
        _c_terminated = $8000;     {        }

        _l_gen_lst =    $0001;          { request for generating listing file }
        _l_pass =       $0002;             {    (pass 2) }
        _l_on =         $0004;            {      }
        _l_line =       $0008; {         }
	_l_notrunc =    $0010;          { do not truncate hex dump in listing }

	_l_gen_xref =   $0300;		      { generate cross reference file }
	_l_xrf_alpha =  $0100;		              { in alphabetical order }
	_l_xrf_num =	$0200;                           { in numerical order }
	_l_xrf_hex =    $0400;	                     { use hex format in xref }
	_l_xrf_dec =    $0800;	                     { use dec format in xref }

        _l_addr_up =    $1000;                    { print addresses in upcase }
        _l_code_up =    $2000;               { print generated code in upcase }
        _l_inc =        $4000; {   include     }
        _l_lno =        $8000;             {       }

        _i_rel  = $20;        {   PC relative  (branch) }
        _i_wrd  = $10;  {       # address mode }
        _i_imd  = $08;                {   # address mode ($00) }
        _i_Zpg  = $04;        {   zero page address mode ($10) }
        _i_ndx  = $02;         {    address mode ($20) }
        _i_abs  = $01;         {   absolute address mode ($30) }

  type stringp = ^string;
       filep =   ^file;

  var code_size:  cardinal;                          { size of generated code }
      c_flags:    word;               { compiler flags (see _c_XXX constants) }
      l_flags:    word;      { listing generator flags (see _l_XXX constants) }
      b_path,                                {     .BIN file }
      p_path,                                {     .PGM file }
      o_path,                                {     .OBJ file }
      c_path,                                {     .CMD file }
      t_path,                                {     .TMP file }
      temp_fname,                                    {     }
      code_fname,                      {        }
      err_fname,                      {        }
      xrf_fname,	    {       cross reference }
      lst_fname:  stringp;         {        }
      cd_file:    file;                       { file      }
      tmp_file:   file;                                      { temporary file }
      cde_name:   string[12];


      start_time: packed record                   { start time of compilation }
        h, m, s, s100: shortint;
      end { start_time };

  procedure rename((*)const(*) old, new: string);        (*) code $5e, $3b; (*)

  procedure remove((*)const(*) fname: string);           (*) code $5e, $37; (*)

{-----------------------------------------------------------------------------}