{-----------------------------------------------------------------------------}
{ Code genearation for MC6800 assembler.                         (c) 1992 YGP }
                                                                  {$ifNdef lst}
    (*) segment (*)
    procedure OpenFiles;
      var s: string[79];

      function str2heap((*)const(*) s: string): pointer;
        var p: stringp;
      begin { str2heap }
        (*) getmemwords(p, length(s) div 2 +1); {*) getmem(p, length(s) +1);{*}
        p^:= s; str2heap:= p;
      end { str2heap };

      procedure open_file(var f: file; path: stringp(*){*); nm: string {*});
      begin { open_file }
        if c_path = nil then
          s:= ''
        else begin
          s:= path^;
        end { if };
        (*) open(f, s, temporary);
        {*) s:= s + nm + '.$$$';
            assign(f, s); FileMode:= 2; rewrite(f, 1);
        {*}
        if IOresult <> 0 then begin
          err_str:= addr(s);
          error(e_open);
        end { if };
      end { open_file };

    begin { OpenFiles }
      {        (    ). }

      {         ,     PGM file. }
      if c_flags and (_c_pgm_file+_c_obj_file+_c_cmd_file+_c_bin_file)=0 then
        c_flags:= c_flags or _c_pgm_file;

      if c_flags and _c_pgm_file <> 0 then begin
        unimplemented('pgm file');
        end
      else if c_flags and _c_obj_file <> 0 then begin
        unimplemented('obj file');
        end
      else if c_flags and (_c_cmd_file + _c_bin_file) <> 0 then begin
        open_file(cd_file, c_path (*){*), '6800code'{*});
	code_fname:= str2heap(s); cf:= addr(cd_file);
      end { if };
    end { OpenFiles };

    procedure WriteBuffer;
      var n: natural;
    begin { WriteBuffer }
      if cf = nil then OpenFiles;
      {          (     ) }
      {  130  (       128    0).    }

      if ndx <= 130 then
        n:= ndx                                      {     }
      else begin
        n:= ndx -130
      end { if };
      BlockWrite(cf^, cd_buff, n);
      if IOresult <> 0 then error(e_write);

      dec(ndx, n); move(cd_buff[n], cd_buff, ndx);
    end { WriteBuffer };

    procedure gen_byte(b: byte);
    begin { gen_byte - generate one byte in resulting code file }
      if c_flags and _c_section = 0 then begin
        if ndx = c_buffsz then WriteBuffer;
        cd_buff[ndx]:= b; inc(code_size); inc(ndx);
      end { if };
      inc(APC.pc);
    end { gen_byte };

    procedure gen_word(w: word);
    begin { gen_word - generate one word in resulting code file }
      if c_flags and _c_section = 0 then begin
        if ndx >= c_buffsz-1 then WriteBuffer;
        cd_buff[ndx]:= hi(w); cd_buff[ndx+1]:= lo(w);
        inc(code_size, 2); inc(ndx, 2);
      end { if };
      inc(APC.pc, 2);
    end { gen_word };

    procedure gen_long(l: longword);
    begin { gen_long - generate one long word in resulting code file }
      if c_flags and _c_section = 0 then begin
	if ndx >= c_buffsz-3 then WriteBuffer;
	cd_buff[ndx+0]:= hi(hiword(l));
	cd_buff[ndx+1]:= lo(hiword(l));
	cd_buff[ndx+2]:= hi(loword(l));
	cd_buff[ndx+3]:= lo(loword(l));
        inc(code_size, 2); inc(ndx, 2);
      end { if };
      inc(APC.pc, 4);
    end { gen_word };

    procedure change_byte(offset: cardinal; b: byte);
      var sv_fpos: longint;
    begin { change_byte - change byte in code at a given offset }
      {        ,       }
      {                .   }
      {           offset < code_size }
      offset:= code_size - offset;    {         }
      if offset <= ndx then {   ,   -  !     }
        cd_buff[ndx-offset]:= b                    { --    }
      else begin    {      (  )    }
        sv_fpos:= filepos(cf^);
        seek(cf^, sv_fpos -(offset -ndx));
        if IOresult <> 0 then error(e_patch);
        blockwrite(cf^, b, 1);
        if IOresult <> 0 then error(e_patch);
        seek(cf^, sv_fpos);
        if IOresult <> 0 then error(e_patch);
      end { if };
    end { change_byte };

    procedure change_word(offset: cardinal; w: word);
      var sv_fpos: longint;
    begin { change_word - change word in code at a given offset }
      {        ,       }
      {                .   }
      {           offset < code_size }
      offset:= code_size - offset;    {         }
      w:= swap(w);
      if offset <= ndx then {   ,   -  !     }
	move(w, cd_buff[ndx-offset], 2)            { --    }
      else begin    {      (  )    }
        sv_fpos:= filepos(cf^);
        seek(cf^, sv_fpos -(offset -ndx));
	if IOresult <> 0 then error(e_patch);
	blockwrite(cf^, w, 2);
        if IOresult <> 0 then error(e_patch);
        seek(cf^, sv_fpos);
        if IOresult <> 0 then error(e_patch);
      end { if };
    end { change_word };

    (*) segment (*)
    procedure FinishUp;

      function str2heap((*)const(*) s: string): pointer;
        var p: stringp;
      begin { str2heap }
        (*) getmemwords(p, length(s) div 2 +1); {*) getmem(p, length(s) +1);{*}
        p^:= s; str2heap:= p;
      end { str2heap };

      procedure free_str(var s: stringp);
      begin { free_str }
        if s <> nil then begin
          (*) freememwords(s, length(s^) div 2 +1);
          {*) freemem(s, length(s^) +1);            {*}
          s:= nil;
        end { if };
      end { free_str };

      procedure calc_chksum;
	var checksum: integer;
	    i, n: integer;
	    buffer: packed array [0..1023] of byte;
      begin { calc_chksum }
	checksum:= 0;
	seek(cf^, 0); if IOresult <> 0 then error(e_patch);
	while not eof(cf^) do begin
	  blockread(cf^, buffer, sizeof(buffer), n);
	  if IOresult <> 0 then error(e_patch);
	  i:= 0;
	  repeat inc(checksum, buffer[i]); inc(i);
	  until i = n;
	end { while };
	checksum:= lo(-integer(lo(checksum)));
	seek(cf^, chk_offset);        if IOresult <> 0 then error(e_patch);
	blockwrite(cf^, checksum, 1); if IOresult <> 0 then error(e_patch);
      end { calc_chksum };

      var _h, _m, _s, _s100: cardinal; n_sec: longint;
          s: string[79];
    begin { FinishUp }
      if c_flags and _c_section <> 0 then error(e_ends_ex);
      if inc_nesting <> 0 then begin
        error(e_unexp_end); (*) return {*) exit {*};
      end { if };
      {???     }
      while lvl <> nil do begin
        unimplemented(' ');
	{        }
	{    expr_labs = nil }
	dispose_tree(lvl^.labs, nil, false); {    close level }
	{   lab      level }
      end { while };

      {     expr_labs    ,   }
      {   .       .    }
      {  global_labs        . }
      {       expr_labs.   }
      {     expr_labs     (..}
      {      .                                     }

      {        Xref     Lst      }
      {   global_labs (    ).       }

      check_tree(false);
      {    undeclared    (    declared) }
      {          unresolverd.	      }
      check_tree(true);

      if (n_errors <> 0) or (l_flags and _l_gen_lst <> 0) or
                            (l_flags and _l_gen_xref = 0) then begin
        dispose_tree(global_labs, nil, false);
        dispose_tree(expr_labs, nil, false);
      end { if };

      WriteBuffer; WriteBuffer;                           { flush file buffer }
      if (chk_offset >= 0) and (n_errors = 0) then begin
	calc_chksum;
      end { if };

      if c_flags and _c_pgm_file <> 0 then begin
        unimplemented('close pgm file');
        end
      else if c_flags and _c_obj_file <> 0 then begin
        unimplemented('close obj file');
        end
      else if c_flags and (_c_cmd_file + _c_bin_file) <> 0 then begin
        close(cd_file);
        if ioresult <> 0 then begin
          err_str:= code_fname; error(e_close);
        end { if };

        if c_path = nil then
          s:= ''
        else begin
          s:= c_path^;
        end { if };
        insert(cde_name, s, length(s)+1);
	if pos('.', cde_name) = 0 then begin
	  if c_flags and _c_cmd_file <> 0 then
	    insert('.cmd', s, length(s)+1)
	  else begin
	    insert('.bin', s, length(s)+1)
	  end { if };
        end { if };

	if n_errors = 0 then begin
	  remove(s); (*){*) inoutres:= 0; {*}
	  rename(code_fname^, s);
	  if IOresult <> 0 then begin
	    err_str:= addr(s); error(e_rename);
	  end { if };
	  free_str(code_fname); code_fname:= str2heap(s);
	end { if };
      end { if };

      {     , ,  (   ,...) }
      if total_lines <> 0 then begin
        write(total_lines, 'line': 5); if total_lines <> 1 then write('s');
        if n_errors <> 0 then begin
          writeln;
          write('*** ', n_errors, ' error');
          if n_errors <> 1 then write('s');
          if n_warnings <> 0 then begin
            writeln(',');
            write('    ', n_warnings, ' warning');
            if n_warnings <> 1 then write('s');
          end { if };
          writeln('.'); end
        else begin
          GetTime(_h, _m, _s, _s100);       {      }
          with start_time do begin
            h:= _h -h; m:= _m -m; s:= _s -s; s100:= _s100 -s100;

            while s100 < 0 do begin inc(s100, 100); dec(s); end { while };
            while s    < 0 do begin inc(s, 60);     dec(m); end { while };
            while m    < 0 do begin inc(m, 60);     dec(h); end { while };
            while h    < 0 do begin inc(h, 24);             end { while };

            n_sec:=    (s100 +5) div 10;   {  n_sec    sec }
            inc(n_sec, 10 * s);
            inc(n_sec, 10 * 60 * m);
            inc(n_sec, 10 * 60 * 60 * longint(h));

            write(',' (*): -2{*)+' '{*}, code_size, 'byte': 5);
            if code_size <> 1 then write('s');
            write(',' (*): -2{*)+' '{*});
            if h <> 0 then write(h,':');   {        }
            if (h <> 0) or (m <> 0) then
              write(m div 10, m mod 10, ':', s div 10, s mod 10)
            else begin
              write(s, '.', (s100 + 5) div 10, 'sec': 4);
            end { if };
            if (n_sec > 9) and (total_lines > n_sec div 10) then begin
              write('(': 2, total_lines / n_sec * 10: 3: 1, 'lps)': 5);
            end { if };
            writeln('.');
            if n_warnings <> 0 then begin
              write(n_warnings, ' warning');
              if n_warnings <> 1 then write('s');
              writeln('.');
            end { if };
          end { with };
        end { if };
      end { if };
    end { FinishUp };

    procedure _gen_rbyte((*)const{*)var{*} apc: APC_rec);
      var offset: cardinal; v: valuep;
    begin { _gen_rbyte }
      case gv.v_kind of
        v_none:;

        v_expr: begin         {     forward  }
          gv.ex^.offs:= code_size;
          if c_flags and _c_section <> 0 then
	    gv.ex^.kind:= _e_dummy + _e_branch
          else begin
	    gv.ex^.kind:= _e_branch; gen_byte(0);
          end { if };
          new(v(*), v_op_sub(*));
          with v^ do begin
            v_kind:= v_op_sub;
            l_op:= gv.ex^.expr;
            if apc._mod = 0 then begin
              new(r_op(*), v_word(*));
              with r_op^ do begin
                v_kind:= v_word; w:= apc.pc
              end { with }; end
            else begin
              unimplemented('relative not to absolute');
            end { if };
          end { with };
          gv.ex^.expr:= v;
        end { when expression };

        v_cnst: begin     { absolute address, so the apc must be absolute too }
          if apc._mod <> 0 then
            error(e_notrel)
          else begin
            offset:= gv.l -apc.pc;
            if (127 < offset) and (offset < $ff80) then begin
              error(e_outrng);
            end { if };
            gen_byte(lo(offset));
          end { if };
        end { when constant };

      else(*):(*)
        error(e_inv_type);
      end { case };
    end { _gen_rbyte };

    procedure _gen_lobytes(_error: integer; n: longint);
    begin { _gen_lobytes }
      if n > 0 then begin
	case gv.v_kind of
	  v_none:;

	  v_expr: begin         {     forward  }
	    if _error > 5 then begin
	      dec(_error, e_patched);
	    end { if };
	    gv.ex^.offs:= code_size;
	    if c_flags and _c_section <> 0 then
	      gv.ex^.kind:= _e_dummy + _e_lobyte + _error
	    else begin
	      if n = 1 then
		gv.ex^.kind:= _e_lobyte + _error
	      else begin
		gv.ex^.kind:= _error + _e_lobts;
		if n < 128 then begin
		  gen_byte(n); dec(n); end
		else begin
		  gen_byte(0); gen_word(n); dec(n, 3);
		end { if };
	      end { w_ws };
	      while n > 0 do begin
		gen_byte(0); dec(n);
	      end { while };
	    end { if };
	  end { when expression };

	  v_cnst: begin
	    if (_error <> 0) and ((gv.l<-128) or (255<gv.l)) then error(_error);
	    repeat gen_byte(gv.l); dec(n);
	    until n = 0;
	  end { v_cnst };
	end { case };
      end { if };
    end { _gen_lobytes };

    procedure _gen_words(_error: integer; n: longint);
    begin { _gen_words }
      if n > 0 then begin
	case gv.v_kind of
	  v_none:;

	  v_expr: begin         {     forward  }
	    if _error > 5 then begin
	      dec(_error, e_patched);
	    end { if };
	    gv.ex^.offs:= code_size;
	    if c_flags and _c_section <> 0 then
	      gv.ex^.kind:= _e_dummy + _error + _e_word
	    else begin
	      if n = 1 then
		gv.ex^.kind:= _e_word + _error
	      else begin
		gv.ex^.kind:= _error + _e_words;
		gen_word(n); dec(n);
	      end { w_ws };
	      while n > 0 do begin
		gen_word(0); dec(n);
	      end { while };
	    end { if };
	  end { when expression };

	  v_cnst: begin
	    if (_error<>0)and((gv.l<-32768)or(65535<gv.l)) then error(_error);
	    repeat dec(n); gen_word(gv.l);
	    until n = 0;
	  end { v_cnst };
	end { case };
      end { if };
    end { _gen_words };

    procedure _gen_longs(_error: integer; n: longint);
    begin { _gen_longs }
      if n > 0 then begin
	case gv.v_kind of
	  v_none:;

	  v_expr: begin         {     forward  }
	    unimplemented('DL');
	    (*
	    if _error > 5 then begin
	      dec(_error, e_patched);
	    end { if };
	    gv.ex^.offs:= code_size;
	    if c_flags and _c_section <> 0 then
	      gv.ex^.kind:= _e_dummy + _error + _e_word
	    else begin
	      if n = 1 then
		gv.ex^.kind:= _e_word + _error
	      else begin
		gv.ex^.kind:= _error + _e_words;
		gen_word(n); dec(n);
	      end { w_ws };
	      while n > 0 do begin
		gen_word(0); dec(n);
	      end { while };
	    end { if };
	    *)
	  end { when expression };

	  v_cnst: begin
	    repeat dec(n); gen_long(gv.l);
	    until n = 0;
	  end { v_cnst };
	end { case };
      end { if };
    end { _gen_longs };
                                                                        {$else}
    procedure skip(N: cardinal);
    begin { skip }
      if ndx + N < c_buffsz then
        inc(ndx, N)
      else begin
        seek(cd_file, filepos(cd_file) + N -c_buffsz +ndx);
        if (IOresult <> 0) then error(e_lst_io);
        ndx:= c_buffsz;
      end { if };
      inc(sv_codesz, N);
    end { skip };

    procedure ReadBuffer;
      var i: cardinal;
    begin { ReadBuffer }
      if ndx = c_buffsz then
        ndx:= 0
      else begin
        move(cd_buff[ndx], cd_buff, c_buffsz -ndx); ndx:= c_buffsz -ndx;
      end { if };
      blockread(cd_file, cd_buff[ndx], c_buffsz -ndx, i);
      if (IOresult <> 0) or (i = 0) then error(e_lst_io);
    end { ReadBuffer };

    function get_byte: byte;
    begin { get_byte }
      if ndx = c_buffsz then ReadBuffer;
      get_byte:= cd_buff[ndx]; inc(ndx); inc(sv_codesz);
    end { get_byte };
                                                                       {$endif}
{-----------------------------------------------------------------------------}