{-----------------------------------------------------------------------------}
{ Assembling 6800 instructions.                                  (c) 1992 YGP }

    procedure _6800_instruction;
      var force_mode: byte; byte_op: boolean; bracket_mode: boolean;
    begin { _6800_instruction }
      {                 }
      {  ,    ...      }
      {   (     .                  }

      if i_descr.flags = $00 then {    (implied mode) }
        {$ifdef lst} begin     {           }
          inc(APC.pc);                               {    }
          if c_flags and _c_section = 0 then begin
            inc(code_size); lst_code:= _CPU_byte;
          end { id }; end
        {$else}
          gen_byte(i_descr.opcode)
        {$endif}
      else if i_descr.flags = _i_rel then begin    {    branch }
        {$ifdef lst}      {     ,     }
          inc(APC.pc, 2);                    {  ,     }
          if c_flags and _c_section = 0 then begin       {   - opcode }
            inc(code_size, 2); lst_code:= _rel2_byte;       {  relative byte }
          end { if };
        {$else}
          gen_byte(i_descr.opcode);                    { generate branch code }
          expression(false, false);
          inc(_apc.pc, 2);
          case gv.v_kind of
            v_none: ;               { do not display error (already displayed }
            v_expr,      {       (   ) }
            v_cnst: _gen_rbyte(_APC);             { generate relative address }
          else(*):(*)
            error(e_inv_brnch);                      { invalid branch operand }
          end { case };
          dec(_apc.pc, 2);
        {$endif} end
      else begin                        {      }
        force_mode:= 0;                 {       }
								   {$ifdef lst}
	if c_flags and _c_section = 0 then lst_code:= _CPU_byte;       {$endif}
        {         .   # }
        if sy = dies then begin         {  '#',   immediate }
          force_mode:= i_descr.flags and (_i_imd + _i_wrd);  {      }
          {$ifNdef lst}    {  ?      LST }
          if force_mode = 0 then error(e_inv_dies);
          {$endif}
          insy; end
        else if (sy = ident) and (idnm = 'X') then begin {   'X' }
          force_mode:= i_descr.flags and _i_ndx; {     }
          if force_mode = 0 then error(e_inv_ndx);
          insy;   {   .     EOL  ;  , }
	  if (sy = eol_sy) or (sy = comment_line) then begin   {   X }
            {$ifdef lst}
            inc(APC.pc, 2);
            if c_flags and _c_section = 0 then inc(code_size, 2);
            {$else}
            gen_byte(shortcard(i_descr.opcode)+$20); gen_byte(0);  { X = X, 0 }
            {$endif}
            (*) return {*) exit {*}; end
	  else if (sy <> comma) and (sy <> l_bra) and (sy <> plus_sy) then
            error(e_comma)
          else begin
            bracket_mode:= sy = l_bra;        {  x[expr] = x, expr }
            insy;
	  end { if };
	end { if };

        expression(false, false);
        {$ifdef lst}
          if c_flags and _c_section = 0 then inc(code_size, 2);
          inc(APC.pc, 2);
        {$endif}
        if sy = comma then begin         {      expr, x }
          if force_mode <> 0 then      {       mode }
            error(e_xcomma)                             { extra comma on line }
          else begin
            insy;
            if (sy <> ident) or (idnm <> 'X') then
              error(e_garbage)
            else begin
              force_mode:= i_descr.flags and _i_ndx; {    }
              if force_mode = 0 then error(e_inv_ndx);
              insy;                                     {  X  }
            end { if };
          end { if }; end
        else if (force_mode = _i_ndx) and bracket_mode then begin
          if sy = r_bra then
            insy
          else begin
            error(e_r_bra);
          end { if };
        end { if };

	case gv.v_kind of
          v_none: { do nothing because of previous error };

          v_expr,          {       }
	  v_cnst: begin
            byte_op:= (gv.v_kind = v_cnst) and (-128 <= gv.l) and (gv.l < 255);
	    case force_mode of
	      _i_imd: begin               {      }
		{$ifNdef lst}
                  gen_byte(i_descr.opcode);
		  _gen_lobytes(e_no_error, 1);
		{$endif}
	      end { when _i_imd };

	      _i_wrd: begin
		{$ifdef lst}
		  if c_flags and _c_section = 0 then begin
		    inc(code_size); lst_code:= _CPU_word;
		  end { if };
		  inc(APC.pc);
		{$else}
		  gen_byte(i_descr.opcode);
		  _gen_words(w_not_word, 1);
		{$endif}
	      end { when _i_wrd };

	      _i_ndx: begin
		{$ifNdef lst}
		  gen_byte(shortcard(i_descr.opcode)+$20);
		  _gen_lobytes(w_not_byte, 1);
		{$endif}
	      end { when _i_ndx };

	      _i_Zpg: begin
		{$ifNdef lst}
		  gen_byte(shortcard(i_descr.opcode)+$10);
		  _gen_lobytes(w_not_byte, 1);
		{$endif}
	      end { when _i_Zpg };

	      _i_abs: begin
		{$ifdef lst}
		  if c_flags and _c_section = 0 then begin
		    inc(code_size); lst_code:= _CPU_word;
		  end { if };
                  inc(APC.pc);
		{$else}
		  gen_byte(shortcard(i_descr.opcode)+$30);
		  _gen_words(w_not_word, 1);
		{$endif}
	      end { when _i_Zpg };

	    else(*):(*)
	      if (i_descr.flags and _i_abs = 0) and
		 (i_descr.flags and _i_Zpg <> 0) then begin   { ZeroPage only }
		{$ifNdef lst}
		  gen_byte(shortcard(i_descr.opcode)+$10);
		  _gen_lobytes(w_not_byte, 1);
		{$endif} end
	      else if byte_op and (i_descr.flags and _i_Zpg <> 0) then begin
		{$ifNdef lst}
		  gen_byte(shortcard(i_descr.opcode)+$10);
                  gen_byte(gv.l)
		{$endif} end
	      else begin
		{$ifdef lst}
		  if c_flags and _c_section = 0 then begin
		    inc(code_size); lst_code:= _CPU_word;
		  end { if };
                  inc(APC.pc);
		{$else}
		  gen_byte(shortcard(i_descr.opcode)+$30);
		  _gen_words(w_not_word, 1);
		{$endif}
	      end { if };
	    end { case };
	  end { when constant };

	else(*):(*)
	  unimplemented('expression of instruction');
	end { case };
      end { if };
                                                                   {$ifdef lst}
      {         ,    OK }
      sy:= comment_line;   {        } {$endif}
    end { _6800_instruction };

{-----------------------------------------------------------------------------}