{-----------------------------------------------------------------------------}
{ Print listing for one line.                                    (c) 1992 YGP }

    procedure list_line;
      label list_lngint, list_int;

      const max_code_s = 17;

      var i, l_sz:  integer;
	  last_b:   shortcard;
	  start_sz,
          wrk:      cardinal;
          s:        string[15];
          code_str: string[max_code_s];
          nest_str: string[3];
          lno_str:  string[11];

      procedure CheckIOresult;
      begin
        if IOresult <> 0 then begin
          c_flags:= c_flags and (_c_terminated xor word($ffff));
          wfname(true); writeln(message);
          write(message, 'Error writing listing file!'); halt(7);
        end { if };
      end { CheckIOresult };

      procedure wr_chk((*)const(*) s: string; size: integer);
      begin { wr_chk }
        write(list, s: size); CheckIOresult;
      end { wr_chk };

      procedure list_byte(n: natural);
        var i: shortint;
      begin { list_byte }
        if l_sz > max_code_s -1 -2*n then
          l_sz:= max_code_s
        else begin
          for i:= 1 to n do begin
            last_b:= get_byte; byte2str(last_b, s);
            move(s[1], code_str[l_sz], 2); inc(l_sz, 2);
          end { for };
          inc(l_sz, 1);
        end { if };
      end { list_byte };

      procedure info_byte(b: byte);
      begin { info_byte }
        if l_sz > max_code_s -2 then
          l_sz:= max_code_s
        else begin
          byte2str(b, s);
          move(s[1], code_str[l_sz], 2); inc(l_sz, 2);
        end { if };
      end { info_byte };

      procedure info_str((*)const(*) s: string);
      begin { info_str }
        if l_sz + length(s) > max_code_s then
          l_sz:= max_code_s
        else begin
          move(s[1], code_str[l_sz], length(s)); inc(l_sz, length(s));
        end { if };
      end { info_str };

      procedure list_space(n: shortcard);
      begin { list_space }
	while (l_sz <= max_code_s) and (n > 0) do begin
	  code_str[l_sz]:= ' '; inc(l_sz); dec(n);
        end { while };
      end { list_space };

    begin { list_line }
      if (lst_inest >= 0) and (l_flags and (_l_on + _l_line) <> 0) then begin
        while lst_line^[length(lst_line^)] in [' ', #9, #13, #10, #26] do begin
          dec(lst_line^[0]);
        end { while };

        fillchar(nest_str, sizeof(nest_str), ' '); nest_str[0]:= #3;
        i:= lst_inest;
        if i <= 3 then
          s:= ''
        else begin
          i:= 3; int2str(i, s);
        end { if };
        fillchar(nest_str[1], i, '>');
        if length(s) = 1 then
          nest_str[2]:= s[1]             {   >X>  X   }
        else begin
          move(s[1], nest_str[1], length(s));
        end { if };

	int2str(lst_lno,lno_str);inc(lno_str[0]);
	lno_str[length(lno_str)]:=' ';

	start_sz:= sv_codesz;
        repeat
          if l_flags and _l_inc = 0 then wr_chk(nest_str, 0);
          if l_flags and _l_lno = 0 then wr_chk(lno_str, 6);

	  word2str(_APC.pc + sv_codesz - start_sz, s); insert(': ', s, 5);
          if l_flags and _l_addr_up <> 0 then UpCaseS(s);
          wr_chk(s, 0);

          fillchar(code_str, sizeof(code_str), ' ');
          code_str[0]:= chr(max_code_s);
          l_sz:= 1;
          (*
	  while (sv_codesz < code_size) and (l_sz < max_code_s) do begin
          *)
          repeat
            case lst_code of       {         }
	      _lst_none: skip(code_size - sv_codesz);  {    }

	      _lst_nbytes: begin
		int2str(gv.l, s);
		info_str(s);
		info_str('=$');
		word2str(gv.l, s);
		info_str(s);
		info_str('[');
		if gv.l = 0 then
		  info_str('__')
		else begin
		  list_byte(1); dec(l_sz);
		end { if };
		info_str(']');
		lst_code:= _lst_none;
	      end { _lst_nbytes };

              _lst_equ: begin                           { list help info only }
		case gv.v_kind of
                  { v_none: ;         }

                  v_real: begin
                    exp2str(gv.r, 13, s);
                    list_space(max_code_s - length(s) -2);
                    info_str('(');
                  end { v_real };

		  v_expr: begin
		    {         }
		    list_space(max_code_s-5);
		    s:= '(__';
		  end { when expression };

                  v_cnst: begin
                    if 0 <= gv.l then begin
                      if 65535 < gv.l then
                        goto list_lngint
                      else begin
                  list_int:
			int2str(gv.l, s);
			info_str('(');
			list_space(6-length(s));
                        info_str(s);
			info_str(' = $');
			word2str(gv.l, s)
                      end { if }; end
                    else if -32768 <= gv.l then
                      goto list_int
                    else begin                           { full longint range }
                  list_lngint:
		      list_space(5);
                      info_str('($');
                      long2str(gv.l, s);
                    end { if };
                  end { when equ to constant };

                else(*):(*)
                  unimplemented('list equ');
                end { case };
                info_str(s);
                info_str(')');
              end { when list equ };

              _lst_bytes: list_byte(1);                  {    }
              _lst_words: list_byte(2);              {   . }
              _lst_longs: list_byte(4);        {    . }

              _rel2_byte: begin                          { branch instruction }
                list_byte(1); list_byte(1);
                wrk:= _APC.pc + last_b + 2;
                if last_b >= 128 then dec(wrk, 256);
                list_space(4);
                info_str('(');
                info_byte(hi(wrk));
                info_byte(lo(wrk));
                info_str(')');
                lst_code:= _lst_none;
              end { when _rel2_byte };

              _CPU_byte:  lst_code:= _lst_bytes;  {      }

              _CPU_word: begin       { single byte opcode and word operand(s) }
                list_byte(1);                       {    }
                lst_code:= _lst_words;          {      }
              end { when _CPU_word };
            end { case };
          until (sv_codesz >= code_size) or (l_sz >= max_code_s);
          (*
          end { while };
          *)

          if l_flags and _l_code_up <> 0 then UpCaseS(code_str);
          wr_chk(code_str, 0);

          if l_flags and _l_inc <> 0 then wr_chk(nest_str, 0);
          if l_flags and _l_lno <> 0 then wr_chk(lno_str, 6);
          if lst_line^ <> ''         then wr_chk(lst_line^, 0);
          writeln(list); CheckIOresult;
          lst_line^:= ''; lno_str:= '';
        until (l_flags and _l_notrunc = 0) or (sv_codesz >= code_size);
	l_flags:= l_flags and (_l_line xor word($ffff));
	if sv_codesz < code_size then begin
          skip(code_size - sv_codesz);
	end { if };
      end { if };
      lst_line^:= '';
    end { list_line };

{ listing format:

1...5...10....5...20....5...30.2..5...40...

___lllll xxxx: bb bb bb bb bb   ---------------------------------------  \
___lllll xxxx: bb bb   (bbbb)   ---------------------------------------   > 0
___lllll xxxx: bb bbbb (bbbb)   ---------------------------------------  /
\_/\____/\____/\_______________/
 3    6     6         17

___xxxx: bb bb bb bb bb   lllll ---------------------------------------  \
___xxxx: bb bb   (bbbb)   lllll ---------------------------------------   > 1
___xxxx: bb bbbb (bbbb)   lllll ---------------------------------------  /
\_/\____/\_______________/\____/
 3    6         17           6

xxxx: bb bb bb bb bb   ___lllll ---------------------------------------  \
xxxx: bb bb   (bbbb)   ___lllll ---------------------------------------   > 2
xxxx: bb bbbb (bbbb)   ___lllll ---------------------------------------  /
\____/\_______________/\_/\____/
   6         17         3    6

{-----------------------------------------------------------------------------}