{$A-,B-,D-,E-,F-,I-,L-,N-,O-,R-,S+,V-}
unit UniPascal; interface

  type Cardinal  = word;
       ShortCard = byte;
       Natural	 = 0..MaxInt;
       LongWord  = LongInt;
       Real	 = Single;

  function HiWord(IntValue: longint): word;	    { Return the high word }
  inline($58		{ pop ax	}	    { from a long integer  }
	/$58);		{ pop ax	}

  function LoWord(IntValue: longint): word;	    { Return the low word }
  inline($58		{ pop ax	}	    { from a long integer }
	/$5A);		{ pop dx	}

  function LongSwap(l: LongInt): LongWord;

  procedure FillWord(var Dest; Count, Filler : Word);
    {-Fill memory starting at Dest with Count instances of Filler}
    inline(
      $58/                     {pop ax    ;AX = Filler}
      $59/                     {pop cx    ;CX = Count}
      $5F/                     {pop di    ;ES:DI => Dest}
      $07/                     {pop es}
      $FC/                     {cld       ;go forward}
      $F2/$AB);                {rep stosw ;fill memory}

  procedure MoveWords(var src, dest; size: cardinal);
  function b2s(b: byte): string;
  function w2s(w: word): string;
  function l2s(l: longint): string;

  procedure ParamStr(n: byte; var s: string);

  procedure getmemwords(var p: pointer; size: cardinal);

  function MsgLimit: word;

  procedure hide_cursor;

  procedure show_cursor;

  procedure clreol;

  procedure GetTime(var h, m, s, s100: word);

  var message: text;

implementation

  procedure getmemwords(var p: pointer; size: cardinal);
  begin
    getmem(p, size*2);
  end { getmemwords };

  function LongSwap(L: LongInt): longword;
  begin
  longswap:= LongInt(swap(LoWord(l)) * 65536 +  swap(HiWord(l)));
  end { longSwap };

  const hexs: packed array [0..15] of char = '0123456789abcdef';

  function b2s(b: byte): string;
  begin
    b2s:= hexs[b div 16] + hexs[b mod 16];
  end { b2s };

  function w2s(w: word): string;
  begin
    w2s:= b2s(hi(w)) + b2s(lo(w));
  end { w2s };

  function l2s(l: longint): string;
  begin
    l2s:= w2s(hiword(l)) + w2s(loword(l));
  end { l2s };

  procedure MoveWords(var src, dest; size: cardinal);
  begin
    move(src, dest, size*2);
  end { movewords };

  procedure ParamStr(n: byte; var s: string);
  begin
    s:= system.paramstr(n);
  end { ParamStr };

  var screen_cols: byte;

  function MsgLimit: word;                         {$L MsgLimit.obj } external;

  procedure hide_cursor;                        {$L hide_cursor.obj } external;

  procedure show_cursor;                        {$L show_cursor.obj } external;

  procedure clreol;                                  {$L clreol.obj } external;

  procedure GetTime(var h, m, s, s100: word);       {$L GetTime.obj } external;

  type FIB = record               { structure of a Turbo File Interface Block }
         Handle:    Word;             {      HANDLE }
         Mode:      Word;                                         {  BufSize }
         BufSize:   Word;
         Private:   Word;
         BufPos:    Word;
         BufEnd:    Word;
         BufPtr:    pointer {^TextBuffer};
         OpenProc:  Pointer;
         InOutProc: Pointer;
         FlushProc: Pointer;
         CloseProc: Pointer;
         UserData:  array[1..16] of Byte;
         Name:      array[0..79] of Char;
         Buffer:    array[0..127] of Char;
       end { FIB };
begin
  { Open message as standard error file }
  Assign(message, ''); Rewrite(message);
  with FIB(message) do begin
    handle:= 2; BufSize:= 1;
  end { with };
end { UniPascal }.